portal = context.getPortalObject()
alarm_tool = portal.portal_alarms

if alarm_tool.isSubscribed() and len(alarm_id_list):
  # No alarm tool is not subscribed, respect this choice and do not activate any alarm

  tag = None
  if must_reindex_context:
    tag = "%s-%s" % (script.id, context.getRelativeUrl())
    context.reindexObject(activate_kw={'tag': tag})

  for alarm_id in alarm_id_list:
    alarm = alarm_tool.restrictedTraverse(alarm_id)
    if alarm.isEnabled():
      # do nothing if the alarm is not enabled

      if alarm.isActive() or (tag is not None):
        # Wait for the previous alarm run to be finished
        # wait for the context to be reindexed before activating the alarm
        # ROMAIN: SQLQueue is used, because I'm not sure if SQLDict drop activities with different after_tag
        # ROMAIN: getId is used, because most alarm script ends with an getId activity
        alarm.activate(queue='SQLQueue', after_path_and_method_id=(alarm.getPath(), 'getId'), after_tag=tag).activeSense()
      else:
        alarm.activeSense()
